' ClockClock24 By K. Moore 25/07/22
' 24 Analogue clocks working together to be a digital clock!
'
' turn off default typing and force explicit typing
Option EXPLICIT
Option DEFAULT NONE
' turn off blinking LED while running
SetPin GP25, DOUT
' Screen = 320*240
Const width = 480
Const height = 320
Const update = 120 ' update at approx 5Hz
' colours used
Const c.face = RGB(72, 72, 136)
Const c.outline = RGB(140,140,140)
Const c.hand = RGB(white)
Const c.bg = RGB(black) '
Const c.displaytime = 3000   ' iterations at 'update' rate
Colour c.hand, c.bg ' Set the default colours


Dim Integer ctrx(7)=(30,90,150,210,270,330,390,450)
Dim Integer ctry(2)=(100,160,220)
Dim Integer dig(3),  min, lmin, hr, nu, k, j, tim, hand, row, col, ck, r=30
Dim Integer test, hl(1)=((r*.95), (r*0.85))
' use if drawing rectangular hands, slower
'Dim Integer hsx(191), hsy(191), hxl(191), hyl(191)
' use if drawing the hour and minute hands seperately
'Dim Integer msx(71), msy(71), mxl(71), myl(71)
' use if drawing triangular hands, faster
Dim Integer hsx(143), hsy(143), hxl(143), hyl(143)
Dim Integer htick(47), htickl(47), hands
Dim Integer bright, brup, off, udt, udh, hc, dayb=90, eveb=50, nightb=2
Dim Float   hpos(47), hinc(47), fine=120, aclk, radh
Const  sx=6, fo=-4, psx=0.6

' use if drawing the hour and minute hands seperately, so 2 arrays, of triangles in this case.
'Dim Integer n(23)=(3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3)
' use for triangular hands, faster
Dim Integer n(47)=(3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3)
' use for rectangular hands, slower
'Dim Integer n(47)=(4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4)
Dim Integer mdig(5,9)=(15,45,45,15,45,45,22,22,22,15,45,45,0,0,0,15,45,30,0,0,0,15,30,45,15,0,22,15,15,45,0,0,0,30,15,45,0,15,0,30,15,30,0,22,22,15,45,45,15,45,0,15,45,45,15,0,0,15,15,45)
Dim Integer hdig(5,9)=(0,15,0,30,15,30,22,22,22,15,15,45,0,15,45,30,30,30,0,0,0,30,45,30,15,45,22,15,45,45,15,45,0,30,30,30,15,45,45,30,30,45,0,22,22,30,15,45,0,0,45,30,30,30,0,45,0,30,45,30)

' set screen backlight to day value
bright=dayb
Backlight bright

test=0
udt=1
aclk=-60/fine

CLS
' draw clock outline
  For row=0 To 7
    For col=0 To 2
      Circle ctrx(row), ctry(col), r,,,c.outline
    Next
  Next
Timer =0
'  For tim=0 To c.displaytime
  Do
    If test Then
      Inc min,1 : If min>59 Then min=0
    Else
      min=Eval(Mid$(Time$,4,2))
    EndIf
' Check to see if Minute has changed, if so update the new hand positions and rates
    If udt Then
      If min<>lmin Then
        lmin=min
        udt=0 : off=0
' Save away the previos hand positions
        Math add htick(),0,htickl() : Math add htick(),0,hpos()
        dig(2)=min\10 : dig(3)=min Mod 10
        hr=Eval(Left$(Time$, 2))
        dig(0)=hr\10 : dig(1)=hr Mod 10
        hands=0
        For hand=0 To 1
' reverse the hand directions
         aclk=aclk* -1
         For row=0 To 7
          j=0
          If row Mod 2 Then j=3
          k=row\2
' reverse the hand directions for each column
          aclk=aclk* -1
          For col=0 To 2
' check for hour or minute hand positions
           If hand Then
            htick(hands)=hdig(col+j,dig(k))
           Else
            htick(hands)=mdig(col+j,dig(k))
           EndIf
' calculate the difference between old and new hand positions
           hc=htick(hands)-htickl(hands)
           If hc=0 Then
             hinc(hands)=aclk
           Else
             hinc(hands)=hc/fine
           EndIf
           Inc hands,1
          Next
         Next
        Next
      EndIf
      Pause update
'      Timer =0
' we have new hand positions, so move hand towards their new positions
    Else
      ck=0
      hands=0
      For hand=0 To 1
       For row=0 To 7
        j=0
        If row Mod 2 Then j=3
        k=row\2
        For col=0 To 2
          Inc hpos(hands),hinc(hands)
' use for rectangular hands, but slower
'          radh=Rad((hpos(hands)+sx)*sx)
'          hsx(ck)= ctrx(row)+Cos(radh)*fo
'          hsy(ck)= ctry(col)+Sin(radh)*fo
'          Inc ck,1
'          radh=Rad((hpos(hands)-sx)*sx)
          radh=Rad(hpos(hands)*sx)
          hsx(ck)= ctrx(row)+Cos(radh)*fo
          hsy(ck)= ctry(col)+Sin(radh)*fo
          Inc ck,1
          radh=Rad((hpos(hands)+psx)*sx)
          hsx(ck)= ctrx(row)+Cos(radh)*hl(hand)
          hsy(ck)= ctry(col)+Sin(radh)*hl(hand)
          Inc ck,1
          radh=Rad((hpos(hands)-psx)*sx)
          hsx(ck)= ctrx(row)+Cos(radh)*hl(hand)
          hsy(ck)= ctry(col)+Sin(radh)*hl(hand)
          Inc ck,1
          Inc hands,1
        Next
       Next
      Next
' Erase the old hands
      'If hxl(0) Then
      Polygon n(),hxl(),hyl(),c.bg,c.bg':Polygon n(),mxl(),myl(),c.bg,c.bg
' Draw the new hands
      Polygon n(),hsx(),hsy(),c.hand,c.hand':Polygon n(),msx(),msy(),c.hand,c.hand
' draw the centre circle, when using triangular hands
      For row=0 To 7
       For col=0 To 2
        Circle ctrx(row),ctry(col), 4,,,,c.hand
       Next
      Next
' copy the new hands, so we can erase them next time
      Math add hsx(),0,hxl():Math add hsy(),0,hyl()':Math add msx(),0,mxl():Math add msy(),0,myl()
' check for when we've finished moving hands
      If off>fine-1 Then udt=1:Print Timer
      Pause update
    EndIf
    Inc off,1
  Loop '  Next
'Print Timer
End

' utility to get the x coord of a vector on the analogue clock
'Function GetX(tim As Float, r As Float, anax As Integer) As Integer 'Float
'  Local Float t = tim
'  Print t;
'  If t>359 Then Inc t,-360
'  If t<0 Then Inc t,360
'  GetX = anax+Cos(Rad(tim*6))*r
'End Function

' utility to get the y coord of a vector on the analogue clock
'Function GetY(tim As Float, r As Float, anay As Integer) As Integer 'Float
'  Local Float t = tim
'  Print "  "t
'  If t>359 Then Inc t,-360
'  If t<0 Then Inc t,360
'  GetY = anay+Sin(Rad(tim*6))*r
'End Function
